#uses "classes/bsa/AKS"

const string ACK_CHARS    = "  x  ";
const string ACK_CHARS1   = " xxx ";
const string NOTACK_CHARS = " !!! ";

/*void invokedAESUserFunc( string shapeName, int screenType, int tabType, int row, int column, string value, mapping mTableRow )
{

}*/

void aes_bsa_workCB_editAlertsBeforeDisplay(const dyn_string &colNames, dyn_dyn_anytype &xtab)
{
  //DebugTN(colNames);
  //DebugTN(xtab);

  mapping mColNames;

  for (int i=0 ; i < colNames.count() ; ++i)
  {
    mColNames.insert(colNames.at(i), i+1);
  }

  for (int i=1 ; i <= dynlen(xtab[1]) ; i++)
  {
    // write the user name who acknowledged the alert
    // this has to be done manually since the standard functionality delivers only the user Id
    if (xtab[mColNames["acknowledge"]][i][1] == ACK_CHARS || xtab[mColNames["acknowledge"]][i][1] == ACK_CHARS1)
    {
      xtab[mColNames["ackUserName"]][i] = getUserName(xtab[mColNames["ackUserId"]][i]);
    }
    else
    {
      xtab[mColNames["ackUserName"]][i] = "";
    }

    //exchange the "  x  " in the acknowledge field with " xxx " to be complient to the TS 07
    if (xtab[mColNames["acknowledge"]][i][1] == ACK_CHARS)
    {
      xtab[mColNames["acknowledge"]][i][1] = ACK_CHARS1;
    }

    //exchange the BG and FG color of the acknowledge field
    xtab[mColNames["acknowledge"]][i][2] = "alertAreaTableBG";
    xtab[mColNames["acknowledge"]][i][3] = "alertAreaText";

    //extrakt the AKS and place the parts into the corresponding columns
    shared_ptr<AKS> aks = AKS::Parse(xtab[mColNames["elementAKS"]][i]);

    xtab[mColNames["AKS1"]][i] = aks.GetErfassungsbereich();
    xtab[mColNames["AKS2"]][i] = aks.GetStreckenabschnitt();
    xtab[mColNames["AKS3"]][i] = aks.GetAbschnitt();
    xtab[mColNames["AKS4"]][i] = aks.GetRichtung();
    xtab[mColNames["AKS5"]][i] = aks.GetSpur();
    xtab[mColNames["AKS6"]][i] = aks.GetRaeumlichkeit();
    xtab[mColNames["AKS7"]][i] = aks.GetStockwerk();
    xtab[mColNames["AKS8"]][i] = aks.GetRaum();
    xtab[mColNames["AKS9"]][i] = aks.GetLage();
    xtab[mColNames["AKS10"]][i] = aks.GetAnlage();
    xtab[mColNames["AKS11"]][i] = aks.GetAnlagenteil();
    xtab[mColNames["AKS12"]][i] = aks.GetGruppe();
    xtab[mColNames["AKS13"]][i] = aks.GetObjekt();
    xtab[mColNames["AKS14"]][i] = aks.GetKodierung();
    xtab[mColNames["AKS15"]][i] = aks.GetFunktion();

  }
}
