// $License: NOLICENSE
//--------------------------------------------------------------------------------
/**
  @file $relPath
  @copyright $copyright
  @author mmarchhart
*/

//--------------------------------------------------------------------------------
// Libraries used (#uses)
#uses "classes/bsa/BleSupervisionUserGroup"

//--------------------------------------------------------------------------------
// Variables and Constants

//--------------------------------------------------------------------------------
/**
*/
class BleSupervisionArea
{
//--------------------------------------------------------------------------------
//@public members
//--------------------------------------------------------------------------------

  //------------------------------------------------------------------------------
  /** The Default Constructor.
  */
  public BleSupervisionArea(const string &name)
  {
    _areaName = name;
  }

  /**
    Sets the list of BLE groups that have supervision authorization in this area
    @param authorizedGroups
  */
  public void SetAuthorizedGroups(const vector<BleSupervisionUserGroup> &authorizedGroups)
  {
    _authorizedGroups = authorizedGroups;
  }

  /**
    Checks if a given user group has supervision authorizaiton in this area
    @param userGroup
    @return
  */
  public bool HasGroupAuthorization(const BleSupervisionUserGroup &userGroup)
  {
    for(int i=0 ; i < _authorizedGroups.count() ; ++i)
    {
      BleSupervisionUserGroup group = _authorizedGroups.at(i);

      if(group.Equals(userGroup))  //mma: if it equals, then the given group has authorization
      {
        return true;
      }
    }

    return false;  //mma: in case no match was found, the given group has NO authorization
  }

//--------------------------------------------------------------------------------
//@protected members
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
//@private data
//--------------------------------------------------------------------------------
  private string _areaName;
  private vector<BleSupervisionUserGroup> _authorizedGroups;
};
