// $License: NOLICENSE
//--------------------------------------------------------------------------------
/**
  @file $relPath
  @copyright $copyright
  @author mmarchhart
*/

//--------------------------------------------------------------------------------
// Libraries used (#uses)

//--------------------------------------------------------------------------------
// Variables and Constants

enum BleUserGroup
{
  NONE,
  OP_1,
  OP_2,
  OP_3,
  OP_4,
  SB_1,
  IB_1
};

//--------------------------------------------------------------------------------
/**
*/
class BleSupervisionUserGroup
{
//--------------------------------------------------------------------------------
//@public members
//--------------------------------------------------------------------------------

  //------------------------------------------------------------------------------
  /** The Default Constructor.
  */
  public BleSupervisionUserGroup(BleUserGroup userGroup = BleUserGroup::NONE)
  {
    _userGroup = userGroup;
  }

  public BleUserGroup GetUserGroupEnum()
  {
    return _userGroup;
  }

  public bool Equals(const BleSupervisionUserGroup &rhs)
  {
    if(rhs._userGroup == _userGroup)
    {
      return true;
    }

    return false;
  }

  public string ToString()
  {
    switch(_userGroup)
    {
      case BleUserGroup::OP_1 :
        return "OP_1";
        break;

      case BleUserGroup::OP_2 :
        return "OP_2";
        break;

      case BleUserGroup::OP_3 :
        return "OP_3";
        break;

      case BleUserGroup::OP_4 :
        return "OP_4";
        break;

      case BleUserGroup::SB_1 :
        return "SB_1";
        break;

      case BleUserGroup::IB_1 :
        return "OP_1";
        break;

      default :
        return "";
    }
  }

  static public BleSupervisionUserGroup FromString(const string &userGroupString)
  {
    BleSupervisionUserGroup userGroup;

    switch(userGroupString)
    {
      case "OP_1" :
        userGroup = BleSupervisionUserGroup(BleUserGroup::OP_1);
        break;

      case "OP_2" :
        userGroup = BleSupervisionUserGroup(BleUserGroup::OP_2);
        break;

      case "OP_3" :
        userGroup = BleSupervisionUserGroup(BleUserGroup::OP_3);
        break;

      case "OP_4" :
        userGroup = BleSupervisionUserGroup(BleUserGroup::OP_4);
        break;

      case "SB_1" :
        userGroup = BleSupervisionUserGroup(BleUserGroup::SB_1);
        break;

      case "IB_1" :
        userGroup = BleSupervisionUserGroup(BleUserGroup::OP_1);
        break;
    }

    return userGroup;
  }
//--------------------------------------------------------------------------------
//@protected members
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
//@private members
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
//@private data
//--------------------------------------------------------------------------------
  private BleUserGroup _userGroup;
};
