// $License: NOLICENSE
//--------------------------------------------------------------------------------
/**
  @file $relPath
  @copyright $copyright
  @author mmarchhart
*/

//--------------------------------------------------------------------------------
// Libraries used (#uses)

//--------------------------------------------------------------------------------
// Variables and Constants

//--------------------------------------------------------------------------------
/**
*/
class BsaControl
{
//--------------------------------------------------------------------------------
//@public members
//--------------------------------------------------------------------------------
  //------------------------------------------------------------------------------
  /** The Default Constructor.
  */
  public BsaControl(string user="", string ui="")
  {
    _user = user;
    _ui = ui;
  }

  /**
    Gives the information if someone has currenly claimed BSA Control
    @return
  */
  public bool IsBsaControl()
  {
    return (_user != "") ? true : false;
  }

  /**
    Retursn the user name who has claimed BSA Control
    @return
  */
  public string GetUserName()
  {
    return _user;
  }

  /**
    Returns the UI number from wherer the user has claimed BSA Control
    @return
  */
  public string GetUI()
  {
    return _ui;
  }

  /**
    Converts the BsaControl object to its raw string representation
    @return
  */
  public string ToString()
  {
    if(_user != "")
    {
      return _user + "@" + _ui;
    }

    else return "";
  }

  /**
    Creates a new BsaControl object from the raw string representation
    @param rawString
    @return
  */
  public static shared_ptr<BsaControl> FromString(const string &rawString)
  {
    vector<string> split = rawString.split("@");

    if(split.count() >= 2)
    {
      return new BsaControl(split.at(0), split.at(1));
    }

    else return new BsaControl();
  }
//--------------------------------------------------------------------------------
//@protected members
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
//@private data
//--------------------------------------------------------------------------------
  private string _user;
  private string _ui;

};
