// $License: NOLICENSE
//--------------------------------------------------------------------------------
/**
  @file $relPath
  @copyright $copyright
  @author mmarchhart
*/

//--------------------------------------------------------------------------------
// Libraries used (#uses)

//--------------------------------------------------------------------------------
// Variables and Constants

//--------------------------------------------------------------------------------
/**
*/
struct BsaJournalCustomFilter
{
//--------------------------------------------------------------------------------
//@public members
//--------------------------------------------------------------------------------

  //------------------------------------------------------------------------------
  /** The Default Constructor.
  */
  public BsaJournalCustomFilter()
  {
    Type = 0;
    Begin = getCurrentTime();
    End = getCurrentTime();
  }

  public string ToJson()
  {
    return jsonEncode(this);
  }

  public static shared_ptr<BsaJournalCustomFilter> FromJson(const string &json)
  {
    shared_ptr<BsaJournalCustomFilter> customFilter = nullptr;

    try
    {
      mapping jsonData = jsonDecode(json);

      customFilter = new BsaJournalCustomFilter();

      customFilter.Type = jsonData.value("Type");
      customFilter.Begin = scanTimeUTC(jsonData.value("Begin"));
      customFilter.End = scanTimeUTC(jsonData.value("End"));
    }
    catch
    {
      throw(makeError("", PRIO_WARNING, ERR_IMPL, 0, "Couldn't decode given json to an BsaJournalCustomFilter object: " + json));
    }

    return customFilter;
  }
//--------------------------------------------------------------------------------
//@protected members
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
//@private members
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
//@public data
//--------------------------------------------------------------------------------
  public uint Type;
  public time Begin;
  public time End;

};
