// $License: NOLICENSE
//--------------------------------------------------------------------------------
/**
  @file $relPath
  @copyright $copyright
  @author mmarchhart
*/

//--------------------------------------------------------------------------------
// Libraries used (#uses)
#uses "classes/bsa/BleSupervisionUserGroup"
//--------------------------------------------------------------------------------
// Variables and Constants

//--------------------------------------------------------------------------------
/**
*/
class BsaUser
{
//--------------------------------------------------------------------------------
//@public members
//--------------------------------------------------------------------------------

  //------------------------------------------------------------------------------
  /** The Default Constructor.
  */
  public BsaUser(const string &userName, BleSupervisionUserGroup userGroup)
  {
    _userName = userName;
    _bleUserGroup = userGroup;
    _workPlace = "";
  }

  /**
    Returns the user name of the BsaUser
    @return
  */
  public string GetUserName()
  {
    return _userName;
  }

  /**
    Returns the BleUserGroup the BsaUser belongs to
    @return
  */
  public BleSupervisionUserGroup GetUserGroup()
  {
    return _bleUserGroup;
  }

  /**
    Sets the workplace the user is located
    @param workplace
  */
  public void SetWorkplace(const string &workplace)
  {
    _workPlace = workplace;
  }

  /**
    Returns the workplace the user is located.
    @return
  */
  public string GetWorkplace()
  {
    return _workPlace;
  }

//--------------------------------------------------------------------------------
//@protected members
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
//@private data
//--------------------------------------------------------------------------------
  private string _userName;
  private BleSupervisionUserGroup _bleUserGroup;
  private string _workPlace;
};
