// $License: NOLICENSE
//--------------------------------------------------------------------------------
/**
  @file $relPath
  @copyright $copyright
  @author mmarchhart
*/

//--------------------------------------------------------------------------------
// Libraries used (#uses)
#uses "classes/bsa/AKS"
#uses "classes/bsa/objectFactory/BsaObjectFactoryInput"

//--------------------------------------------------------------------------------
// Variables and Constants

//--------------------------------------------------------------------------------
/**
*/
class BsaTestObjectFactoryInput : BsaObjectFactoryInput
{
//--------------------------------------------------------------------------------
//@public members
//--------------------------------------------------------------------------------

  //------------------------------------------------------------------------------
  /** The Default Constructor.
  */
  public BsaTestObjectFactoryInput(shared_ptr<AKS> objectAKS) : BsaObjectFactoryInput(objectAKS)
  {
    _alarm1AKS = objectAKS.Copy();
    _alarm1AKS.SetFunktion("ALARM");

    _alarm2AKS = objectAKS.Copy();
    _alarm2AKS.SetFunktion("STO11");
  }

  public void SetAlarm1AKS(shared_ptr<AKS> aks)
  {
    assignPtr(_alarm1AKS, aks);
  }

  public shared_ptr<AKS> GetAlarm1AKS()
  {
    return _alarm1AKS;
  }

  public void SetAlarm2AKS(shared_ptr<AKS> aks)
  {
    assignPtr(_alarm2AKS, aks);
  }

  public shared_ptr<AKS> GetAlarm2AKS()
  {
    return _alarm2AKS;
  }

  public string GetAlarm1AKSasString()
  {
    return _alarm1AKS.ToString();
  }

  public string GetAlarm2AKSasString()
  {
    return _alarm2AKS.ToString();
  }

//--------------------------------------------------------------------------------
//@protected members
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
//@private members
//--------------------------------------------------------------------------------
  private shared_ptr<AKS> _alarm1AKS;
  private shared_ptr<AKS> _alarm2AKS;
};
