// $License: NOLICENSE
//--------------------------------------------------------------------------------
/**
  @file $relPath
  @copyright $copyright
  @author mmarchhart
*/

//--------------------------------------------------------------------------------
// Libraries used (#uses)
#uses "classes/sode/ISodeDataReceiver"
#uses "classes/sode/replies/BaseReply"

//--------------------------------------------------------------------------------
// Variables and Constants

//--------------------------------------------------------------------------------
/**
*/
class HMISodeDataReceiver : ISodeDataReceiver
{
//--------------------------------------------------------------------------------
//@public members
//--------------------------------------------------------------------------------

  //------------------------------------------------------------------------------
  /** The Default Constructor.
  */
  public HMISodeDataReceiver(shape dataCB)
  {
    _dataCB = dataCB;
  }

  //implementation of ISodeDataReceiver
  public void RawReplyDataReceived(const string &data)
  {
    if(_dataCB != nullptr) _dataCB.SodeRawReplyDataReceived(data);
  }

  //implementation of ISodeDataReceiver
  public void ReplyReceived(shared_ptr<BaseReply> reply)
  {
    if(_dataCB != nullptr) _dataCB.SodeReplyReceived(reply);
  }

  //implementation of ISodeDataReceiver
  public void ConnectionStatusChanged(bool connected)
  {
    if(_dataCB != nullptr) _dataCB.SodeConnectionStatusChanged(connected);
  }

//--------------------------------------------------------------------------------
//@protected members
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
//@private members
//--------------------------------------------------------------------------------
  private shape _dataCB;
};
