// $License: NOLICENSE
//--------------------------------------------------------------------------------
/**
  @file $relPath
  @copyright $copyright
  @author mmarchhart
*/

//--------------------------------------------------------------------------------
// Libraries used (#uses)
#uses "CtrlXml"

//--------------------------------------------------------------------------------
// Variables and Constants

enum ReplyStatus
{
  OK,
  ERROR
};

struct ReplyContent
{
  string Command;
  ReplyStatus Status;
  string Msg;
  mapping Parameter;
};

//--------------------------------------------------------------------------------
/**
*/
class BaseReply
{
//--------------------------------------------------------------------------------
//@public members
//--------------------------------------------------------------------------------

  //------------------------------------------------------------------------------
  /** The Default Constructor.
  */
  public BaseReply(const ReplyContent &content)
  {
    _content = content;
  }

  public string GetCommand()
  {
    return _content.Command;
  }

  public ReplyStatus GetStatus()
  {
    return _content.Status;
  }

  public string GetMessage()
  {
    return _content.Msg;
  }
//--------------------------------------------------------------------------------
//@protected members
//--------------------------------------------------------------------------------
  protected string GetParameterValue(const string &parameter)
  {
    mapping paramters = _content.Parameter;

    if(paramters.contains(parameter))
    {
      return paramters.value(parameter);
    }
    else throw(makeError("", PRIO_SEVERE, ERR_IMPL, 1, "Parameter " + parameter + " does not exist in reply message for: " + _command));
  }

//--------------------------------------------------------------------------------
//@private members
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
//@private data
//--------------------------------------------------------------------------------
  private ReplyContent _content;
};
