// $License: NOLICENSE
//--------------------------------------------------------------------------------
/**
  @file $relPath
  @copyright $copyright
  @author mmarchhart
*/

//--------------------------------------------------------------------------------
// Libraries used (#uses)
#uses "classes/tcp/ITcpDataReceiver"

//--------------------------------------------------------------------------------
// Variables and Constants

//--------------------------------------------------------------------------------
/**
*/
class HMITcpDataReceiver : ITcpDataReceiver
{
//--------------------------------------------------------------------------------
//@public members
//--------------------------------------------------------------------------------

  //------------------------------------------------------------------------------
  /** The Default Constructor.
  */
  public HMITcpDataReceiver(shape dataCB)
  {
    _dataCB = dataCB;
  }

  //implementation of ITcpDataReceiver
  public void DataReceived(const string &data)
  {
    if(_dataCB != nullptr) _dataCB.TcpDataReceived(data);
  }

  //implementation of ITcpDataReceiver
  public void ConnectionStatusChanged(bool connected)
  {
    if(_dataCB != nullptr) _dataCB.TcpConnectionStatusChanged(connected);
  }

//--------------------------------------------------------------------------------
//@protected members
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
//@private members
//--------------------------------------------------------------------------------
  private shape _dataCB;
};
