// $License: NOLICENSE
//--------------------------------------------------------------------------------
/**
  @file $relPath
  @copyright $copyright
  @author mmarchhart
*/

//--------------------------------------------------------------------------------
// Libraries used (#uses)

//--------------------------------------------------------------------------------
// Variables and Constants

//--------------------------------------------------------------------------------
/**
*/
class ITcpDataReceiver
{
//--------------------------------------------------------------------------------
//@public members
//--------------------------------------------------------------------------------

  //------------------------------------------------------------------------------
  /** The Default Constructor.
  */
  public ITcpDataReceiver()
  {
  }

  /**
    An implementing class must override this to further handle received data from the tcp connection
    @param data
  */
  public void DataReceived(const string &data)
  {
  }


  /**
    An implementing class can override this to react on connection status changes (connected|disconnected)
    @param connected
  */
  public void ConnectionStatusChanged(bool connected)
  {
  }

//--------------------------------------------------------------------------------
//@protected members
//--------------------------------------------------------------------------------


//--------------------------------------------------------------------------------
//@private members
//--------------------------------------------------------------------------------

};
