// $License: NOLICENSE
//--------------------------------------------------------------------------------
/**
  @file $relPath
  @copyright $copyright
  @author mmarchhart
*/

//--------------------------------------------------------------------------------
// Libraries used (#uses)
#uses "classes/bsa/AKS"
#uses "classes/bsa/objectFactory/BsaObjectFactoryInput"

//--------------------------------------------------------------------------------
// Variables and Constants

//--------------------------------------------------------------------------------
/**
*/
class VmsCameraFactoryInput : BsaObjectFactoryInput
{
//--------------------------------------------------------------------------------
//@public members
//--------------------------------------------------------------------------------

  //------------------------------------------------------------------------------
  /** The Default Constructor.
  */
  public VmsCameraFactoryInput(shared_ptr<AKS> objectAKS) : BsaObjectFactoryInput(objectAKS)
  {
    _alarm1AKS = objectAKS.Copy();
    _alarm1AKS.SetFunktion("UWACH");
  }

  public void SetUrl(const string &url)
  {
    _url = url;
  }

  public string GetUrl()
  {
    return _url;
  }

  public void SetMonitorText(const string &monitorText)
  {
    _monitorText = monitorText;
  }

  public string GetMonitorText()
  {
    return _monitorText;
  }

  public void SetHost(const string &host)
  {
    _host = host;
  }

  public string GetHost()
  {
    return _host;
  }

  public void SetAlarm1AKS(shared_ptr<AKS> aks)
  {
    assignPtr(_alarm1AKS, aks);
  }

  public shared_ptr<AKS> GetAlarm1AKS()
  {
    return _alarm1AKS;
  }

  public string GetAlarm1AKSasString()
  {
    return _alarm1AKS.ToString();
  }
//--------------------------------------------------------------------------------
//@protected members
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
//@private members
//--------------------------------------------------------------------------------
  private shared_ptr<AKS> _alarm1AKS;
  private string _url;
  private string _monitorText;
  private string _host;

};
