// $License: NOLICENSE
//--------------------------------------------------------------------------------
/**
  @file $relPath
  @copyright $copyright
  @author mmarchhart
*/

//--------------------------------------------------------------------------------
// Libraries used (#uses)

//--------------------------------------------------------------------------------
// Variables and Constants

//--------------------------------------------------------------------------------
/**
*/
struct SodeDisplayInfo
{
//--------------------------------------------------------------------------------
//@public members
//--------------------------------------------------------------------------------

  //------------------------------------------------------------------------------
  /** The Default Constructor.
  */
  public SodeDisplayInfo(const string &cameraDp, string text = "", string addText = "")
  {
    CameraDP = cameraDp;
    Text = text;
    AddText = addText;
  }

  public string ToJson()
  {
    return jsonEncode(this);
  }

  public static shared_ptr<SodeDisplayInfo> FromJson(const string &json)
  {
    shared_ptr<SodeDisplayInfo> displayInfo = nullptr;

    if(json != "")
    {
      try
      {
        mapping jsonData = jsonDecode(json);

        displayInfo = new SodeDisplayInfo(jsonData.value("CameraDP"),
                                          jsonData.value("Text"),
                                          jsonData.value("AddText"));
      }
      catch
      {
        throw(makeError("", PRIO_WARNING, ERR_IMPL, 0, "Couldn't decode given json to an SodeDisplayInfo object: " + json));
      }
    }
    else
    {
      displayInfo = new SodeDisplayInfo("");
    }

    return displayInfo;
  }

  public string GetCameraUrl()
  {
    string url;

    if(dpExists(CameraDP))
    {
      dpGet(CameraDP + ".config.url", url);
    }

    return url;
  }

//--------------------------------------------------------------------------------
//@protected members
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
//@public data
//--------------------------------------------------------------------------------
  public string CameraDP;
  public string Text;
  public string AddText;

};
