// $License: NOLICENSE
//--------------------------------------------------------------------------------
/**
  @file $relPath
  @copyright $copyright
  @author mmarchhart
*/

//--------------------------------------------------------------------------------
// Libraries used (#uses)
#uses "classes/bsa/AKS"
#uses "classes/bsa/objectFactory/BsaObjectFactoryInput"

//--------------------------------------------------------------------------------
// Variables and Constants

//--------------------------------------------------------------------------------
/**
*/
class VmsSodeFactoryInput : BsaObjectFactoryInput
{
//--------------------------------------------------------------------------------
//@public members
//--------------------------------------------------------------------------------

  //------------------------------------------------------------------------------
  /** The Default Constructor.
  */
  public VmsSodeFactoryInput(shared_ptr<AKS> objectAKS) : BsaObjectFactoryInput(objectAKS)
  {
    _alarm1AKS = objectAKS.Copy();
    _alarm1AKS.SetFunktion("UWACH");
  }

  public void SetHost(const string &host)
  {
    _host = host;
  }

  public string GetHost()
  {
    return _host;
  }

  public void SetPort(int port)
  {
    _port = port;
  }

  public int GetPort()
  {
    return _port;
  }

  public void SetAlarm1AKS(shared_ptr<AKS> aks)
  {
    assignPtr(_alarm1AKS, aks);
  }

  public shared_ptr<AKS> GetAlarm1AKS()
  {
    return _alarm1AKS;
  }

  public string GetAlarm1AKSasString()
  {
    return _alarm1AKS.ToString();
  }
//--------------------------------------------------------------------------------
//@protected members
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
//@private members
//--------------------------------------------------------------------------------
  private shared_ptr<AKS> _alarm1AKS;
  private string _host;
  private int _port;

};
