// $License: NOLICENSE
//--------------------------------------------------------------------------------
/**
  @file $relPath
  @copyright $copyright
  @author mmarchhart
*/

//--------------------------------------------------------------------------------
// Libraries used (#uses)
#uses "classes/sode/ISodeDataReceiver"
#uses "classes/bsa/BsaObject"

//--------------------------------------------------------------------------------
// Variables and Constants

//--------------------------------------------------------------------------------
/**
*/
class SodeObjectInterfaceDataReceiver : ISodeDataReceiver
{
//--------------------------------------------------------------------------------
//@public members
//--------------------------------------------------------------------------------

  //------------------------------------------------------------------------------
  /** The Default Constructor.
  */
  public SodeObjectInterfaceDataReceiver(const string &sodeObjectDP)
  {
    _sodeObjectDP = sodeObjectDP;
  }

  //implementation of ISodeDataReceiver
  public void ConnectionStatusChanged(bool connected)
  {
    BsaModeServe modeServe;
    int alert1Value;

    if(connected)
    {
      modeServe = BsaModeServe::BLE;
      alert1Value = 0;  //mma: no alert
    }
    else
    {
      modeServe = BsaModeServe::INVALID;
      alert1Value = 1;  //mma: if not connected, also rais alert_1 (UWACH)
    }

    dpSetWait(_sodeObjectDP + ".cmdio.mode_serve", (int)modeServe,
              _sodeObjectDP + ".alerts.alert_1", alert1Value);
  }

//--------------------------------------------------------------------------------
//@protected members
//--------------------------------------------------------------------------------

//--------------------------------------------------------------------------------
//@private data
//--------------------------------------------------------------------------------
  private string _sodeObjectDP;
};
